/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

package com.phidget22;
import java.util.*;

public class SoundSensorBase extends Phidget {

	SoundSensorBase(long handle) {
		super(handle);
	}

	public SoundSensorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableSPLChangeEvents(enable && SPLChangeListeners.size() > 0);
	}

	public final void addSPLChangeListener(SoundSensorSPLChangeListener l) {
		synchronized(SPLChangeListeners) {
			SPLChangeListeners.add(l);
			enableSPLChangeEvents(true);
		}
	}
	private List<SoundSensorSPLChangeListener> SPLChangeListeners = new ArrayList<SoundSensorSPLChangeListener>();
	private long nativeSPLChangeHandler = 0;
	public final void removeSPLChangeListener(SoundSensorSPLChangeListener l) {
		synchronized(SPLChangeListeners) {
			SPLChangeListeners.remove(l);
			enableSPLChangeEvents(SPLChangeListeners.size() > 0);
		}
	}
	private void fireSPLChange(SoundSensorSPLChangeEvent e) {
		synchronized(SPLChangeListeners) {
			for (Iterator it = SPLChangeListeners.iterator (); it.hasNext();)
			((SoundSensorSPLChangeListener) it.next ()).onSPLChange (e);
		}
	}
	private native void enableSPLChangeEvents(boolean b);


	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getdB() throws PhidgetException;
	public native double getMaxdB() throws PhidgetException;
	public native double getdBA() throws PhidgetException;
	public native double getdBC() throws PhidgetException;
	public native double getNoiseFloor() throws PhidgetException;
	public native double[] getOctaves() throws PhidgetException;
	public native double getSPLChangeTrigger() throws PhidgetException;
	public native void setSPLChangeTrigger(double SPLChangeTrigger) throws PhidgetException;
	public native double getMinSPLChangeTrigger() throws PhidgetException;
	public native double getMaxSPLChangeTrigger() throws PhidgetException;
	public native SPLRange getSPLRange() throws PhidgetException;
	public native void setSPLRange(SPLRange SPLRange) throws PhidgetException;
}
