/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_DigitalOutputBase.h"

static jclass digitalOutputbase_class;
jclass digitalOutput_class;
jmethodID digitalOutput_cons;

void com_phidget22_DigitalOutputBase_OnLoad(JNIEnv *env) {
	if (!(digitalOutput_class = (*env)->FindClass(env, "com/phidget22/DigitalOutput")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DigitalOutput");
	if (!(digitalOutput_class = (jclass)(*env)->NewGlobalRef(env, digitalOutput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef digitalOutput_class");
	if (!(digitalOutput_cons = (*env)->GetMethodID(env, digitalOutput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from digitalOutput_class");

	if (!(digitalOutputbase_class = (*env)->FindClass(env, "com/phidget22/DigitalOutputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DigitalOutputBase");
	if (!(digitalOutputbase_class = (jclass)(*env)->NewGlobalRef(env, digitalOutputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef digitalOutputbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_DigitalOutputBase_create(JNIEnv * env, jclass obj) {
	PhidgetDigitalOutputHandle phid;
	int error; 
	if ((error = PhidgetDigitalOutput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getDutyCycle(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dutyCycle;
	ret = PhidgetDigitalOutput_getDutyCycle(h, &dutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dutyCycle;
	}
	return dutyCycle;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setDutyCycle__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble dutyCycle, jobject asyncHandler) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetDigitalOutput_setDutyCycle_async(h, (double)dutyCycle, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setDutyCycle__D(JNIEnv * env, jobject obj, jdouble dutyCycle) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_setDutyCycle(h, (double)dutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMinDutyCycle(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDutyCycle;
	ret = PhidgetDigitalOutput_getMinDutyCycle(h, &minDutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDutyCycle;
	}
	return minDutyCycle;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMaxDutyCycle(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDutyCycle;
	ret = PhidgetDigitalOutput_getMaxDutyCycle(h, &maxDutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDutyCycle;
	}
	return maxDutyCycle;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_enableFailsafe(JNIEnv * env, jobject obj, jint failsafeTime) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_enableFailsafe(h, (uint32_t)failsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_DigitalOutputBase_getMinFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minFailsafeTime;
	ret = PhidgetDigitalOutput_getMinFailsafeTime(h, &minFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minFailsafeTime;
	}
	return minFailsafeTime;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DigitalOutputBase_getMaxFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxFailsafeTime;
	ret = PhidgetDigitalOutput_getMaxFailsafeTime(h, &maxFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxFailsafeTime;
	}
	return maxFailsafeTime;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getLEDCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double LEDCurrentLimit;
	ret = PhidgetDigitalOutput_getLEDCurrentLimit(h, &LEDCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return LEDCurrentLimit;
	}
	return LEDCurrentLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setLEDCurrentLimit__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble LEDCurrentLimit, jobject asyncHandler) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetDigitalOutput_setLEDCurrentLimit_async(h, (double)LEDCurrentLimit, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setLEDCurrentLimit__D(JNIEnv * env, jobject obj, jdouble LEDCurrentLimit) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_setLEDCurrentLimit(h, (double)LEDCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMinLEDCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minLEDCurrentLimit;
	ret = PhidgetDigitalOutput_getMinLEDCurrentLimit(h, &minLEDCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minLEDCurrentLimit;
	}
	return minLEDCurrentLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMaxLEDCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxLEDCurrentLimit;
	ret = PhidgetDigitalOutput_getMaxLEDCurrentLimit(h, &maxLEDCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxLEDCurrentLimit;
	}
	return maxLEDCurrentLimit;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_DigitalOutputBase_getLEDForwardVoltage(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetDigitalOutput_LEDForwardVoltage LEDForwardVoltage;
	ret = PhidgetDigitalOutput_getLEDForwardVoltage(h, &LEDForwardVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, LEDForwardVoltage_class, LEDForwardVoltage_getEnum_mid, LEDForwardVoltage);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setLEDForwardVoltage(JNIEnv * env, jobject obj, jobject LEDForwardVoltage) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_setLEDForwardVoltage(h, (PhidgetDigitalOutput_LEDForwardVoltage)(*env)->CallIntMethod(env, LEDForwardVoltage, LEDForwardVoltage_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_resetFailsafe(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_resetFailsafe(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_DigitalOutputBase_getState(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int state;
	ret = PhidgetDigitalOutput_getState(h, &state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return state;
	}
	return state;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setState__Z(JNIEnv * env, jobject obj, jboolean state) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_setState(h, (int)state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setState__ZLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jboolean state, jobject asyncHandler) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetDigitalOutput_setState_async(h, (int)state, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}
