/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_EncoderBase.h"

static jclass encoderbase_class;
jclass encoder_class;
jmethodID encoder_cons;

static jclass positionChangeEvent_class;
static jmethodID firePositionChange_mid	;
static jmethodID positionChangeEvent_cons;
static jfieldID nativePositionChangeHandler_fid;

void com_phidget22_EncoderBase_OnLoad(JNIEnv *env) {
	if (!(encoder_class = (*env)->FindClass(env, "com/phidget22/Encoder")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/Encoder");
	if (!(encoder_class = (jclass)(*env)->NewGlobalRef(env, encoder_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef encoder_class");
	if (!(encoder_cons = (*env)->GetMethodID(env, encoder_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from encoder_class");

	if (!(encoderbase_class = (*env)->FindClass(env, "com/phidget22/EncoderBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/EncoderBase");
	if (!(encoderbase_class = (jclass)(*env)->NewGlobalRef(env, encoderbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef encoderbase_class");

	if (!(positionChangeEvent_class = (*env)->FindClass(env, "com/phidget22/EncoderPositionChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/EncoderPositionChangeEvent");
	if (!(positionChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, positionChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref PositionChangeEvent_class");
	if (!(firePositionChange_mid = (*env)->GetMethodID(env, encoderbase_class, "firePositionChange", "(Lcom/phidget22/EncoderPositionChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID firePositionChange");
	if (!(positionChangeEvent_cons = (*env)->GetMethodID(env, positionChangeEvent_class, "<init>", "(Lcom/phidget22/Encoder;IDZ)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from PositionChangeEvent_class");
	if (!(nativePositionChangeHandler_fid = (*env)->GetFieldID(env, encoderbase_class, "nativePositionChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativePositionChangeHandler from encoderbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_EncoderBase_create(JNIEnv * env, jclass obj) {
	PhidgetEncoderHandle phid;
	int error; 
	if ((error = PhidgetEncoder_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setEnabled(JNIEnv * env, jobject obj, jboolean enabled) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setEnabled(h, (int)enabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_EncoderBase_getEnabled(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int enabled;
	ret = PhidgetEncoder_getEnabled(h, &enabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return enabled;
	}
	return enabled;
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetEncoder_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetEncoder_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetEncoder_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jlong JNICALL Java_com_phidget22_EncoderBase_getIndexPosition(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int64_t indexPosition;
	ret = PhidgetEncoder_getIndexPosition(h, &indexPosition);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return indexPosition;
	}
	return indexPosition;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_EncoderBase_getIOMode(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_EncoderIOMode IOMode;
	ret = PhidgetEncoder_getIOMode(h, &IOMode);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, EncoderIOMode_class, EncoderIOMode_getEnum_mid, IOMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setIOMode(JNIEnv * env, jobject obj, jobject IOMode) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setIOMode(h, (Phidget_EncoderIOMode)(*env)->CallIntMethod(env, IOMode, EncoderIOMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jlong JNICALL Java_com_phidget22_EncoderBase_getPosition(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int64_t position;
	ret = PhidgetEncoder_getPosition(h, &position);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return position;
	}
	return position;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setPosition(JNIEnv * env, jobject obj, jlong position) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setPosition(h, (int64_t)position);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getPositionChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t positionChangeTrigger;
	ret = PhidgetEncoder_getPositionChangeTrigger(h, &positionChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return positionChangeTrigger;
	}
	return positionChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setPositionChangeTrigger(JNIEnv * env, jobject obj, jint positionChangeTrigger) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setPositionChangeTrigger(h, (uint32_t)positionChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getMinPositionChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minPositionChangeTrigger;
	ret = PhidgetEncoder_getMinPositionChangeTrigger(h, &minPositionChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minPositionChangeTrigger;
	}
	return minPositionChangeTrigger;
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getMaxPositionChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxPositionChangeTrigger;
	ret = PhidgetEncoder_getMaxPositionChangeTrigger(h, &maxPositionChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxPositionChangeTrigger;
	}
	return maxPositionChangeTrigger;
}

static void CCONV positionChange_handler(PhidgetEncoderHandle h, void *arg, int positionChange, double timeChange, int indexTriggered) {
	jobject positionChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((positionChangeEv = (*env)->NewObject(env, positionChangeEvent_class, positionChangeEvent_cons, obj, positionChange, timeChange, indexTriggered)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePositionChange_mid, positionChangeEv);
		(*env)->DeleteLocalRef(env, positionChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_enablePositionChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativePositionChangeHandler_fid, b);
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetEncoder_setOnPositionChangeHandler(h, b ? positionChange_handler : NULL, (void *)(uintptr_t) gr);
}
