/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_LCDBase.h"

static jclass LCDbase_class;
jclass LCD_class;
jmethodID LCD_cons;

void com_phidget22_LCDBase_OnLoad(JNIEnv *env) {
	if (!(LCD_class = (*env)->FindClass(env, "com/phidget22/LCD")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LCD");
	if (!(LCD_class = (jclass)(*env)->NewGlobalRef(env, LCD_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef LCD_class");
	if (!(LCD_cons = (*env)->GetMethodID(env, LCD_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from LCD_class");

	if (!(LCDbase_class = (*env)->FindClass(env, "com/phidget22/LCDBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LCDBase");
	if (!(LCDbase_class = (jclass)(*env)->NewGlobalRef(env, LCDbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef LCDbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_LCDBase_create(JNIEnv * env, jclass obj) {
	PhidgetLCDHandle phid;
	int error; 
	if ((error = PhidgetLCD_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getBacklight(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double backlight;
	ret = PhidgetLCD_getBacklight(h, &backlight);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return backlight;
	}
	return backlight;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setBacklight(JNIEnv * env, jobject obj, jdouble backlight) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_setBacklight(h, (double)backlight);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getMinBacklight(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minBacklight;
	ret = PhidgetLCD_getMinBacklight(h, &minBacklight);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minBacklight;
	}
	return minBacklight;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getMaxBacklight(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxBacklight;
	ret = PhidgetLCD_getMaxBacklight(h, &maxBacklight);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxBacklight;
	}
	return maxBacklight;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setCharacterBitmap__Lcom_phidget22_LCDFont_2Ljava_lang_String_2_3B(JNIEnv * env, jobject obj, jobject font, jstring character, jbyteArray bitmap) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *characterUTFChars = (character == NULL ? NULL : (*env)->GetStringUTFChars(env, character, NULL));
	uint8_t *bitmapArr = (*env)->GetByteArrayElements(env, bitmap, 0);
	ret = PhidgetLCD_setCharacterBitmap(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (const char *)characterUTFChars, bitmapArr);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (characterUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, character, characterUTFChars);
		(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
		return;
	}
	if (characterUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, character, characterUTFChars);
	(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setCharacterBitmap__Lcom_phidget22_LCDFont_2Ljava_lang_String_2_3BLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jobject font, jstring character, jbyteArray bitmap, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	const char *characterUTFChars = (character == NULL ? NULL : (*env)->GetStringUTFChars(env, character, NULL));
	uint8_t *bitmapArr = (*env)->GetByteArrayElements(env, bitmap, 0);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_setCharacterBitmap_async(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (const char *)characterUTFChars, bitmapArr, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
	if (characterUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, character, characterUTFChars);
	(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
}

JNIEXPORT jint JNICALL Java_com_phidget22_LCDBase_getMaxCharacters(JNIEnv * env, jobject obj, jobject font) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int maxCharacters;
	ret = PhidgetLCD_getMaxCharacters(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), &maxCharacters);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxCharacters;
	}
	return maxCharacters;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_clear__Lcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_clear_async(h, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_clear__(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_clear(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getContrast(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double contrast;
	ret = PhidgetLCD_getContrast(h, &contrast);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return contrast;
	}
	return contrast;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setContrast(JNIEnv * env, jobject obj, jdouble contrast) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_setContrast(h, (double)contrast);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getMinContrast(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minContrast;
	ret = PhidgetLCD_getMinContrast(h, &minContrast);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minContrast;
	}
	return minContrast;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getMaxContrast(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxContrast;
	ret = PhidgetLCD_getMaxContrast(h, &maxContrast);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxContrast;
	}
	return maxContrast;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_copy__IIIIIIIIZ(JNIEnv * env, jobject obj, jint sourceFramebuffer, jint destFramebuffer, jint sourceX1, jint sourceY1, jint sourceX2, jint sourceY2, jint destX, jint destY, jboolean inverted) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_copy(h, (int)sourceFramebuffer, (int)destFramebuffer, (int)sourceX1, (int)sourceY1, (int)sourceX2, (int)sourceY2, (int)destX, (int)destY, (int)inverted);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_copy__IIIIIIIIZLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint sourceFramebuffer, jint destFramebuffer, jint sourceX1, jint sourceY1, jint sourceX2, jint sourceY2, jint destX, jint destY, jboolean inverted, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_copy_async(h, (int)sourceFramebuffer, (int)destFramebuffer, (int)sourceX1, (int)sourceY1, (int)sourceX2, (int)sourceY2, (int)destX, (int)destY, (int)inverted, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LCDBase_getCursorBlink(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int cursorBlink;
	ret = PhidgetLCD_getCursorBlink(h, &cursorBlink);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return cursorBlink;
	}
	return cursorBlink;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setCursorBlink(JNIEnv * env, jobject obj, jboolean cursorBlink) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_setCursorBlink(h, (int)cursorBlink);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LCDBase_getCursorOn(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int cursorOn;
	ret = PhidgetLCD_getCursorOn(h, &cursorOn);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return cursorOn;
	}
	return cursorOn;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setCursorOn(JNIEnv * env, jobject obj, jboolean cursorOn) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_setCursorOn(h, (int)cursorOn);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawLine__IIIILcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint x1, jint y1, jint x2, jint y2, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_drawLine_async(h, (int)x1, (int)y1, (int)x2, (int)y2, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawLine__IIII(JNIEnv * env, jobject obj, jint x1, jint y1, jint x2, jint y2) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_drawLine(h, (int)x1, (int)y1, (int)x2, (int)y2);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawPixel__IILcom_phidget22_LCDPixelState_2(JNIEnv * env, jobject obj, jint x, jint y, jobject pixelState) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_drawPixel(h, (int)x, (int)y, (PhidgetLCD_PixelState)(*env)->CallIntMethod(env, pixelState, LCDPixelState_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawPixel__IILcom_phidget22_LCDPixelState_2Lcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint x, jint y, jobject pixelState, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_drawPixel_async(h, (int)x, (int)y, (PhidgetLCD_PixelState)(*env)->CallIntMethod(env, pixelState, LCDPixelState_getCode_mid), asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawRect__IIIIZZLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint x1, jint y1, jint x2, jint y2, jboolean filled, jboolean inverted, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_drawRect_async(h, (int)x1, (int)y1, (int)x2, (int)y2, (int)filled, (int)inverted, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawRect__IIIIZZ(JNIEnv * env, jobject obj, jint x1, jint y1, jint x2, jint y2, jboolean filled, jboolean inverted) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_drawRect(h, (int)x1, (int)y1, (int)x2, (int)y2, (int)filled, (int)inverted);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_flush__(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_flush(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_flush__Lcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_flush_async(h, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setFontSize(JNIEnv * env, jobject obj, jobject font, jint width, jint height) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_setFontSize(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (int)width, (int)height);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_LCDBase_getFrameBuffer(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int frameBuffer;
	ret = PhidgetLCD_getFrameBuffer(h, &frameBuffer);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return frameBuffer;
	}
	return frameBuffer;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setFrameBuffer__I(JNIEnv * env, jobject obj, jint frameBuffer) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_setFrameBuffer(h, (int)frameBuffer);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setFrameBuffer__ILcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint frameBuffer, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_setFrameBuffer_async(h, (int)frameBuffer, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT jint JNICALL Java_com_phidget22_LCDBase_getHeight(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int height;
	ret = PhidgetLCD_getHeight(h, &height);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return height;
	}
	return height;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_initialize(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_initialize(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_saveFrameBuffer__ILcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint frameBuffer, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_saveFrameBuffer_async(h, (int)frameBuffer, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_saveFrameBuffer__I(JNIEnv * env, jobject obj, jint frameBuffer) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_saveFrameBuffer(h, (int)frameBuffer);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_LCDBase_getScreenSize(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetLCD_ScreenSize screenSize;
	ret = PhidgetLCD_getScreenSize(h, &screenSize);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, LCDScreenSize_class, LCDScreenSize_getEnum_mid, screenSize);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setScreenSize(JNIEnv * env, jobject obj, jobject screenSize) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_setScreenSize(h, (PhidgetLCD_ScreenSize)(*env)->CallIntMethod(env, screenSize, LCDScreenSize_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LCDBase_getSleeping(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int sleeping;
	ret = PhidgetLCD_getSleeping(h, &sleeping);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return sleeping;
	}
	return sleeping;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setSleeping(JNIEnv * env, jobject obj, jboolean sleeping) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLCD_setSleeping(h, (int)sleeping);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_LCDBase_getWidth(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int width;
	ret = PhidgetLCD_getWidth(h, &width);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return width;
	}
	return width;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_writeBitmap__IIII_3BLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint xPosition, jint yPosition, jint xSize, jint ySize, jbyteArray bitmap, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	uint8_t *bitmapArr = (*env)->GetByteArrayElements(env, bitmap, 0);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_writeBitmap_async(h, (int)xPosition, (int)yPosition, (int)xSize, (int)ySize, bitmapArr, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
	(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_writeBitmap__IIII_3B(JNIEnv * env, jobject obj, jint xPosition, jint yPosition, jint xSize, jint ySize, jbyteArray bitmap) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint8_t *bitmapArr = (*env)->GetByteArrayElements(env, bitmap, 0);
	ret = PhidgetLCD_writeBitmap(h, (int)xPosition, (int)yPosition, (int)xSize, (int)ySize, bitmapArr);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
		return;
	}
	(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_writeText__Lcom_phidget22_LCDFont_2IILjava_lang_String_2(JNIEnv * env, jobject obj, jobject font, jint xPosition, jint yPosition, jstring text) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *textUTFChars = (text == NULL ? NULL : (*env)->GetStringUTFChars(env, text, NULL));
	ret = PhidgetLCD_writeText(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (int)xPosition, (int)yPosition, (const char *)textUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (textUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, text, textUTFChars);
		return;
	}
	if (textUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, text, textUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_writeText__Lcom_phidget22_LCDFont_2IILjava_lang_String_2Lcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jobject font, jint xPosition, jint yPosition, jstring text, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	const char *textUTFChars = (text == NULL ? NULL : (*env)->GetStringUTFChars(env, text, NULL));
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_writeText_async(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (int)xPosition, (int)yPosition, (const char *)textUTFChars, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
	if (textUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, text, textUTFChars);
}
