/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_NetBase.h"

static jclass netbase_class;
jclass net_class;

static jclass serverAddedEvent_class;
static jmethodID fireServerAdded_mid	;
static jmethodID serverAddedEvent_cons;
static jfieldID nativeServerAddedHandler_fid;

static jclass serverRemovedEvent_class;
static jmethodID fireServerRemoved_mid	;
static jmethodID serverRemovedEvent_cons;
static jfieldID nativeServerRemovedHandler_fid;

void com_phidget22_NetBase_OnLoad(JNIEnv *env) {
	if (!(net_class = (*env)->FindClass(env, "com/phidget22/Net")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/Net");
	if (!(net_class = (jclass)(*env)->NewGlobalRef(env, net_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef net_class");

	if (!(netbase_class = (*env)->FindClass(env, "com/phidget22/NetBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/NetBase");
	if (!(netbase_class = (jclass)(*env)->NewGlobalRef(env, netbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef netbase_class");

	if (!(serverAddedEvent_class = (*env)->FindClass(env, "com/phidget22/NetServerAddedEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/NetServerAddedEvent");
	if (!(serverAddedEvent_class = (jclass)(*env)->NewGlobalRef(env, serverAddedEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref ServerAddedEvent_class");
	if (!(fireServerAdded_mid = (*env)->GetMethodID(env, netbase_class, "fireServerAdded", "(Lcom/phidget22/NetServerAddedEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireServerAdded");
	if (!(serverAddedEvent_cons = (*env)->GetMethodID(env, serverAddedEvent_class, "<init>", "(Lcom/phidget22/Net;Lcom/phidget22/PhidgetServer;J)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from ServerAddedEvent_class");
	if (!(nativeServerAddedHandler_fid = (*env)->GetFieldID(env, netbase_class, "nativeServerAddedHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeServerAddedHandler from netbase_class");

	if (!(serverRemovedEvent_class = (*env)->FindClass(env, "com/phidget22/NetServerRemovedEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/NetServerRemovedEvent");
	if (!(serverRemovedEvent_class = (jclass)(*env)->NewGlobalRef(env, serverRemovedEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref ServerRemovedEvent_class");
	if (!(fireServerRemoved_mid = (*env)->GetMethodID(env, netbase_class, "fireServerRemoved", "(Lcom/phidget22/NetServerRemovedEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireServerRemoved");
	if (!(serverRemovedEvent_cons = (*env)->GetMethodID(env, serverRemovedEvent_class, "<init>", "(Lcom/phidget22/Net;Lcom/phidget22/PhidgetServer;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from ServerRemovedEvent_class");
	if (!(nativeServerRemovedHandler_fid = (*env)->GetFieldID(env, netbase_class, "nativeServerRemovedHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeServerRemovedHandler from netbase_class");
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_addServer(JNIEnv * env, jobject obj, jstring serverName, jstring address, jint port, jstring password, jint flags) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	const char *addressUTFChars = (address == NULL ? NULL : (*env)->GetStringUTFChars(env, address, NULL));
	const char *passwordUTFChars = (password == NULL ? NULL : (*env)->GetStringUTFChars(env, password, NULL));
	ret = PhidgetNet_addServer((const char *)serverNameUTFChars, (const char *)addressUTFChars, (int)port, (const char *)passwordUTFChars, (int)flags);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		if (addressUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, address, addressUTFChars);
		if (passwordUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, password, passwordUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
	if (addressUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, address, addressUTFChars);
	if (passwordUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, password, passwordUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_removeServer(JNIEnv * env, jobject obj, jstring serverName) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	ret = PhidgetNet_removeServer((const char *)serverNameUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_enableServer(JNIEnv * env, jobject obj, jstring serverName) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	ret = PhidgetNet_enableServer((const char *)serverNameUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_disableServer(JNIEnv * env, jobject obj, jstring serverName, jint flags) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	ret = PhidgetNet_disableServer((const char *)serverNameUTFChars, (int)flags);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_enableServerDiscovery(JNIEnv * env, jobject obj, jobject serverType) {
	PhidgetReturnCode ret;
	ret = PhidgetNet_enableServerDiscovery((PhidgetServerType)(*env)->CallIntMethod(env, serverType, ServerType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_disableServerDiscovery(JNIEnv * env, jobject obj, jobject serverType) {
	PhidgetReturnCode ret;
	ret = PhidgetNet_disableServerDiscovery((PhidgetServerType)(*env)->CallIntMethod(env, serverType, ServerType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_setServerPassword(JNIEnv * env, jobject obj, jstring serverName, jstring password) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	const char *passwordUTFChars = (password == NULL ? NULL : (*env)->GetStringUTFChars(env, password, NULL));
	ret = PhidgetNet_setServerPassword((const char *)serverNameUTFChars, (const char *)passwordUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		if (passwordUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, password, passwordUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
	if (passwordUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, password, passwordUTFChars);
}

static void CCONV serverAdded_handler(void *arg, PhidgetServer *server, void * kv) {
	jobject serverAddedEv;
	JNIEnv *env;
	jobject obj;
	jobject serverObj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	serverObj = PhidgetServer_to_jobject(env, server);

	if ((serverAddedEv = (*env)->NewObject(env, serverAddedEvent_class, serverAddedEvent_cons, obj, serverObj, kv)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireServerAdded_mid, serverAddedEv);
		(*env)->DeleteLocalRef(env, serverAddedEv);
	}
	(*env)->DeleteLocalRef(env, serverObj);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_enableServerAddedEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeServerAddedHandler_fid, b);
	PhidgetNet_setOnServerAddedHandler(b ? serverAdded_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV serverRemoved_handler(void *arg, PhidgetServer *server) {
	jobject serverRemovedEv;
	JNIEnv *env;
	jobject obj;
	jobject serverObj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	serverObj = PhidgetServer_to_jobject(env, server);

	if ((serverRemovedEv = (*env)->NewObject(env, serverRemovedEvent_class, serverRemovedEvent_cons, obj, serverObj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireServerRemoved_mid, serverRemovedEv);
		(*env)->DeleteLocalRef(env, serverRemovedEv);
	}
	(*env)->DeleteLocalRef(env, serverObj);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_enableServerRemovedEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeServerRemovedHandler_fid, b);
	PhidgetNet_setOnServerRemovedHandler(b ? serverRemoved_handler : NULL, (void *)(uintptr_t) gr);
}
