/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_PHSensorBase.h"

static jclass PHSensorbase_class;
jclass PHSensor_class;
jmethodID PHSensor_cons;

static jclass PHChangeEvent_class;
static jmethodID firePHChange_mid	;
static jmethodID PHChangeEvent_cons;
static jfieldID nativePHChangeHandler_fid;

void com_phidget22_PHSensorBase_OnLoad(JNIEnv *env) {
	if (!(PHSensor_class = (*env)->FindClass(env, "com/phidget22/PHSensor")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PHSensor");
	if (!(PHSensor_class = (jclass)(*env)->NewGlobalRef(env, PHSensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef PHSensor_class");
	if (!(PHSensor_cons = (*env)->GetMethodID(env, PHSensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from PHSensor_class");

	if (!(PHSensorbase_class = (*env)->FindClass(env, "com/phidget22/PHSensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PHSensorBase");
	if (!(PHSensorbase_class = (jclass)(*env)->NewGlobalRef(env, PHSensorbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef PHSensorbase_class");

	if (!(PHChangeEvent_class = (*env)->FindClass(env, "com/phidget22/PHSensorPHChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PHSensorPHChangeEvent");
	if (!(PHChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, PHChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref PHChangeEvent_class");
	if (!(firePHChange_mid = (*env)->GetMethodID(env, PHSensorbase_class, "firePHChange", "(Lcom/phidget22/PHSensorPHChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID firePHChange");
	if (!(PHChangeEvent_cons = (*env)->GetMethodID(env, PHChangeEvent_class, "<init>", "(Lcom/phidget22/PHSensor;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from PHChangeEvent_class");
	if (!(nativePHChangeHandler_fid = (*env)->GetFieldID(env, PHSensorbase_class, "nativePHChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativePHChangeHandler from PHSensorbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_PHSensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetPHSensorHandle phid;
	int error; 
	if ((error = PhidgetPHSensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getCorrectionTemperature(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double correctionTemperature;
	ret = PhidgetPHSensor_getCorrectionTemperature(h, &correctionTemperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return correctionTemperature;
	}
	return correctionTemperature;
}

JNIEXPORT void JNICALL Java_com_phidget22_PHSensorBase_setCorrectionTemperature(JNIEnv * env, jobject obj, jdouble correctionTemperature) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPHSensor_setCorrectionTemperature(h, (double)correctionTemperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getMinCorrectionTemperature(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minCorrectionTemperature;
	ret = PhidgetPHSensor_getMinCorrectionTemperature(h, &minCorrectionTemperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minCorrectionTemperature;
	}
	return minCorrectionTemperature;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getMaxCorrectionTemperature(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxCorrectionTemperature;
	ret = PhidgetPHSensor_getMaxCorrectionTemperature(h, &maxCorrectionTemperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxCorrectionTemperature;
	}
	return maxCorrectionTemperature;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PHSensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetPHSensor_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_PHSensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPHSensor_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_PHSensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetPHSensor_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PHSensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetPHSensor_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getPH(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double PH;
	ret = PhidgetPHSensor_getPH(h, &PH);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return PH;
	}
	return PH;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getMinPH(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minPH;
	ret = PhidgetPHSensor_getMinPH(h, &minPH);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minPH;
	}
	return minPH;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getMaxPH(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxPH;
	ret = PhidgetPHSensor_getMaxPH(h, &maxPH);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxPH;
	}
	return maxPH;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getPHChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double PHChangeTrigger;
	ret = PhidgetPHSensor_getPHChangeTrigger(h, &PHChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return PHChangeTrigger;
	}
	return PHChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_PHSensorBase_setPHChangeTrigger(JNIEnv * env, jobject obj, jdouble PHChangeTrigger) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPHSensor_setPHChangeTrigger(h, (double)PHChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getMinPHChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minPHChangeTrigger;
	ret = PhidgetPHSensor_getMinPHChangeTrigger(h, &minPHChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minPHChangeTrigger;
	}
	return minPHChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PHSensorBase_getMaxPHChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxPHChangeTrigger;
	ret = PhidgetPHSensor_getMaxPHChangeTrigger(h, &maxPHChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxPHChangeTrigger;
	}
	return maxPHChangeTrigger;
}

static void CCONV PHChange_handler(PhidgetPHSensorHandle h, void *arg, double PH) {
	jobject PHChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((PHChangeEv = (*env)->NewObject(env, PHChangeEvent_class, PHChangeEvent_cons, obj, PH)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePHChange_mid, PHChangeEv);
		(*env)->DeleteLocalRef(env, PHChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PHSensorBase_enablePHChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativePHChangeHandler_fid, b);
	PhidgetPHSensorHandle h = (PhidgetPHSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetPHSensor_setOnPHChangeHandler(h, b ? PHChange_handler : NULL, (void *)(uintptr_t) gr);
}
