/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_ResistanceInputBase.h"

static jclass resistanceInputbase_class;
jclass resistanceInput_class;
jmethodID resistanceInput_cons;

static jclass resistanceChangeEvent_class;
static jmethodID fireResistanceChange_mid	;
static jmethodID resistanceChangeEvent_cons;
static jfieldID nativeResistanceChangeHandler_fid;

void com_phidget22_ResistanceInputBase_OnLoad(JNIEnv *env) {
	if (!(resistanceInput_class = (*env)->FindClass(env, "com/phidget22/ResistanceInput")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ResistanceInput");
	if (!(resistanceInput_class = (jclass)(*env)->NewGlobalRef(env, resistanceInput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef resistanceInput_class");
	if (!(resistanceInput_cons = (*env)->GetMethodID(env, resistanceInput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from resistanceInput_class");

	if (!(resistanceInputbase_class = (*env)->FindClass(env, "com/phidget22/ResistanceInputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ResistanceInputBase");
	if (!(resistanceInputbase_class = (jclass)(*env)->NewGlobalRef(env, resistanceInputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef resistanceInputbase_class");

	if (!(resistanceChangeEvent_class = (*env)->FindClass(env, "com/phidget22/ResistanceInputResistanceChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ResistanceInputResistanceChangeEvent");
	if (!(resistanceChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, resistanceChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref ResistanceChangeEvent_class");
	if (!(fireResistanceChange_mid = (*env)->GetMethodID(env, resistanceInputbase_class, "fireResistanceChange", "(Lcom/phidget22/ResistanceInputResistanceChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireResistanceChange");
	if (!(resistanceChangeEvent_cons = (*env)->GetMethodID(env, resistanceChangeEvent_class, "<init>", "(Lcom/phidget22/ResistanceInput;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from ResistanceChangeEvent_class");
	if (!(nativeResistanceChangeHandler_fid = (*env)->GetFieldID(env, resistanceInputbase_class, "nativeResistanceChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeResistanceChangeHandler from resistanceInputbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_ResistanceInputBase_create(JNIEnv * env, jclass obj) {
	PhidgetResistanceInputHandle phid;
	int error; 
	if ((error = PhidgetResistanceInput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_ResistanceInputBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetResistanceInput_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetResistanceInput_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_ResistanceInputBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetResistanceInput_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_ResistanceInputBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetResistanceInput_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getResistance(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double resistance;
	ret = PhidgetResistanceInput_getResistance(h, &resistance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return resistance;
	}
	return resistance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMinResistance(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minResistance;
	ret = PhidgetResistanceInput_getMinResistance(h, &minResistance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minResistance;
	}
	return minResistance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMaxResistance(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxResistance;
	ret = PhidgetResistanceInput_getMaxResistance(h, &maxResistance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxResistance;
	}
	return maxResistance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getResistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double resistanceChangeTrigger;
	ret = PhidgetResistanceInput_getResistanceChangeTrigger(h, &resistanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return resistanceChangeTrigger;
	}
	return resistanceChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_setResistanceChangeTrigger(JNIEnv * env, jobject obj, jdouble resistanceChangeTrigger) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetResistanceInput_setResistanceChangeTrigger(h, (double)resistanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMinResistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minResistanceChangeTrigger;
	ret = PhidgetResistanceInput_getMinResistanceChangeTrigger(h, &minResistanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minResistanceChangeTrigger;
	}
	return minResistanceChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMaxResistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxResistanceChangeTrigger;
	ret = PhidgetResistanceInput_getMaxResistanceChangeTrigger(h, &maxResistanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxResistanceChangeTrigger;
	}
	return maxResistanceChangeTrigger;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_ResistanceInputBase_getRTDWireSetup(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_RTDWireSetup RTDWireSetup;
	ret = PhidgetResistanceInput_getRTDWireSetup(h, &RTDWireSetup);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, RTDWireSetup_class, RTDWireSetup_getEnum_mid, RTDWireSetup);
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_setRTDWireSetup(JNIEnv * env, jobject obj, jobject RTDWireSetup) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetResistanceInput_setRTDWireSetup(h, (Phidget_RTDWireSetup)(*env)->CallIntMethod(env, RTDWireSetup, RTDWireSetup_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV resistanceChange_handler(PhidgetResistanceInputHandle h, void *arg, double resistance) {
	jobject resistanceChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((resistanceChangeEv = (*env)->NewObject(env, resistanceChangeEvent_class, resistanceChangeEvent_cons, obj, resistance)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireResistanceChange_mid, resistanceChangeEv);
		(*env)->DeleteLocalRef(env, resistanceChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_enableResistanceChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeResistanceChangeHandler_fid, b);
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetResistanceInput_setOnResistanceChangeHandler(h, b ? resistanceChange_handler : NULL, (void *)(uintptr_t) gr);
}
